Index: /trunk/src/sys/arch/mips/mips/pmap_segtab.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/pmap_segtab.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/pmap_segtab.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: pmap_segtab.c,v 1.1.2.7 2010/05/04 17:14:47 matt Exp $	*/
+/*	$NetBSD: pmap_segtab.c,v 1.1.2.10 2011/04/29 08:26:29 matt Exp $	*/
 
 /*-
@@ -68,5 +68,5 @@
 #include <sys/cdefs.h>
 
-__KERNEL_RCSID(0, "$NetBSD: pmap_segtab.c,v 1.1.2.7 2010/05/04 17:14:47 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: pmap_segtab.c,v 1.1.2.10 2011/04/29 08:26:29 matt Exp $");
 
 /*
@@ -115,10 +115,9 @@
 #include "opt_cputype.h"
 #include "opt_mips_cache.h"
+#include "opt_multiprocessor.h"
 
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/proc.h>
-#include <sys/user.h>
-#include <sys/buf.h>
 #include <sys/pool.h>
 #include <sys/mutex.h>
@@ -136,7 +135,7 @@
 #include <mips/pte.h>
 
-CTASSERT(NBPG >= sizeof(struct segtab));
-
-struct segtab * volatile free_segtab;		/* free list kept locally */
+CTASSERT(NBPG >= sizeof(union segtab));
+
+union segtab * volatile free_segtab;		/* free list kept locally */
 #ifdef DEBUG
 uint32_t nget_segtab;
@@ -157,11 +156,15 @@
 pmap_segmap(struct pmap *pmap, vaddr_t va)
 {
-	struct segtab *stp = pmap->pm_segtab;
+	union segtab *stp = pmap->pm_segtab;
 	KASSERT(!MIPS_KSEG0_P(va));
 	KASSERT(!MIPS_KSEG1_P(va));
 #ifdef _LP64
 	KASSERT(!MIPS_XKPHYS_P(va));
-#endif
-	return stp->seg_tab[va >> SEGSHIFT];
+	stp = stp->seg_seg[(va >> XSEGSHIFT) & (NSEGPG - 1)];
+	if (stp == NULL)
+		return NULL;
+#endif
+	
+	return stp->seg_tab[(va >> SEGSHIFT) & (PMAP_SEGTABSIZE - 1)];
 }
 
@@ -174,4 +177,73 @@
 
 	return pte + ((va >> PGSHIFT) & (NPTEPG - 1));
+}
+
+static void
+pmap_segtab_free(union segtab *stp)
+{
+	/*
+	 * Insert the the segtab into the segtab freelist.
+	 */
+	for (;;) {
+		void *tmp = free_segtab;
+		stp->seg_tab[0] = tmp;
+		if (tmp == atomic_cas_ptr(&free_segtab, tmp, stp)) {
+			SEGTAB_ADD(nput, 1);
+			break;
+		}
+	}
+}
+
+static void
+pmap_segtab_release(union segtab *stp, u_int level)
+{
+
+	for (size_t i = 0; i < PMAP_SEGTABSIZE; i++) {
+		paddr_t pa;
+#ifdef _LP64
+		if (level > 0) {
+			if (stp->seg_seg[i] != NULL) {
+				pmap_segtab_release(stp->seg_seg[i], level - 1);
+				stp->seg_seg[i] = NULL;
+			}
+			continue;
+		}
+#endif
+
+		/* get pointer to segment map */
+		pt_entry_t *pte = stp->seg_tab[i];
+		if (pte == NULL)
+			continue;
+#ifdef PARANOIADIAG
+		for (size_t j = 0; j < NPTEPG; j++) {
+			if ((pte + j)->pt_entry)
+				panic("pmap_destroy: segmap not empty");
+		}
+#endif
+
+#ifdef MIPS3_PLUS	/* XXX mmu XXX */
+		/*
+		 * The pica pmap.c flushed the segmap pages here.  I'm
+		 * not sure why, but I suspect it's because the page(s)
+		 * were being accessed by KSEG0 (cached) addresses and
+		 * may cause cache coherency problems when the page
+		 * is reused with KSEG2 (mapped) addresses.  This may
+		 * cause problems on machines without VCED/VCEI.
+		 */
+		if (MIPS_CACHE_VIRTUAL_ALIAS)
+			mips_dcache_inv_range((vaddr_t)pte, PAGE_SIZE);
+#endif	/* MIPS3_PLUS */
+#ifdef _LP64
+		KASSERT(MIPS_XKPHYS_P(pte));
+		pa = MIPS_XKPHYS_TO_PHYS(pte);
+#else
+		pa = MIPS_KSEG0_TO_PHYS(pte);
+#endif
+		uvm_pagefree(PHYS_TO_VM_PAGE(pa));
+
+		stp->seg_tab[i] = NULL;
+	}
+
+	pmap_segtab_free(stp);
 }
 
@@ -188,14 +260,14 @@
  *	is bounded by that size.
  */
-void
-pmap_segtab_alloc(pmap_t pmap)
-{
-	struct segtab *stp;
+static union segtab *
+pmap_segtab_alloc(void)
+{
+	union segtab *stp;
  again:
 	stp = NULL;
 	while (__predict_true(free_segtab != NULL)) {
-		struct segtab *next_stp;
+		union segtab *next_stp;
 		stp = free_segtab;
-		next_stp = (struct segtab *)stp->seg_tab[0];
+		next_stp = (union segtab *)stp->seg_tab[0];
 		if (stp == atomic_cas_ptr(&free_segtab, stp, next_stp)) {
 			SEGTAB_ADD(nget, 1);
@@ -221,9 +293,9 @@
 #ifdef _LP64
 		KASSERT(mips_options.mips3_xkphys_cached);
-		stp = (struct segtab *)MIPS_PHYS_TO_XKPHYS_CACHED(stp_pa);
-#else
-		stp = (struct segtab *)MIPS_PHYS_TO_KSEG0(stp_pa);
-#endif
-		const size_t n = NBPG / sizeof(struct segtab);
+		stp = (union segtab *)MIPS_PHYS_TO_XKPHYS_CACHED(stp_pa);
+#else
+		stp = (union segtab *)MIPS_PHYS_TO_KSEG0(stp_pa);
+#endif
+		const size_t n = NBPG / sizeof(union segtab);
 		if (n > 1) {
 			/*
@@ -252,6 +324,15 @@
 	}
 #endif
-
-	pmap->pm_segtab = stp;
+	return stp;
+}
+
+/*
+ * Allocate the top segment table for the pmap.
+ */
+void
+pmap_segtab_init(pmap_t pmap)
+{
+
+	pmap->pm_segtab = pmap_segtab_alloc();
 }
 
@@ -262,58 +343,16 @@
  */
 void
-pmap_segtab_free(pmap_t pmap)
-{
-	struct segtab *stp = pmap->pm_segtab;
+pmap_segtab_destroy(pmap_t pmap)
+{
+	union segtab *stp = pmap->pm_segtab;
 
 	if (stp == NULL)
 		return;
 
-	for (size_t i = 0; i < PMAP_SEGTABSIZE; i++) {
-		paddr_t pa;
-		/* get pointer to segment map */
-		pt_entry_t *pte = stp->seg_tab[i];
-		if (pte == NULL)
-			continue;
-#ifdef PARANOIADIAG
-		for (size_t j = 0; j < NPTEPG; j++) {
-			if ((pte + j)->pt_entry)
-				panic("pmap_destroy: segmap not empty");
-		}
-#endif
-
-#ifdef MIPS3_PLUS	/* XXX mmu XXX */
-		/*
-		 * The pica pmap.c flushed the segmap pages here.  I'm
-		 * not sure why, but I suspect it's because the page(s)
-		 * were being accessed by KSEG0 (cached) addresses and
-		 * may cause cache coherency problems when the page
-		 * is reused with KSEG2 (mapped) addresses.  This may
-		 * cause problems on machines without VCED/VCEI.
-		 */
-		if (MIPS_CACHE_VIRTUAL_ALIAS)
-			mips_dcache_inv_range((vaddr_t)pte, PAGE_SIZE);
-#endif	/* MIPS3_PLUS */
-#ifdef _LP64
-		KASSERT(MIPS_XKPHYS_P(pte));
-		pa = MIPS_XKPHYS_TO_PHYS(pte);
-#else
-		pa = MIPS_KSEG0_TO_PHYS(pte);
-#endif
-		uvm_pagefree(PHYS_TO_VM_PAGE(pa));
-
-		stp->seg_tab[i] = NULL;
-	}
-
-	/*
-	 * Insert the the segtab into the segtab freelist.
-	 */
-	for (;;) {
-		void *tmp = free_segtab;
-		stp->seg_tab[0] = tmp;
-		if (tmp == atomic_cas_ptr(&free_segtab, tmp, stp)) {
-			SEGTAB_ADD(nput, 1);
-			break;
-		}
-	}
+#ifdef _LP64
+	pmap_segtab_release(stp, 1);
+#else
+	pmap_segtab_release(stp, 0);
+#endif
 }
 
@@ -326,5 +365,14 @@
 	if (l == curlwp) {
 		KASSERT(pm == l->l_proc->p_vmspace->vm_map.pmap);
-		l->l_cpu->ci_pmap_segbase = pm->pm_segtab;
+#ifdef _LP64
+		l->l_cpu->ci_pmap_segtab = pm->pm_segtab;
+		if (pm != pmap_kernel()) {
+			l->l_cpu->ci_pmap_seg0tab = pm->pm_segtab->seg_seg[0];
+		} else {
+			l->l_cpu->ci_pmap_seg0tab = NULL;
+		}
+#else
+		l->l_cpu->ci_pmap_seg0tab = pm->pm_segtab;
+#endif
 	}
 }
@@ -376,9 +424,27 @@
 pmap_pte_reserve(pmap_t pmap, vaddr_t va, int flags)
 {
-	struct segtab *stp = pmap->pm_segtab;
+	union segtab *stp = pmap->pm_segtab;
 	pt_entry_t *pte;
 
 	pte = pmap_pte_lookup(pmap, va);
 	if (__predict_false(pte == NULL)) {
+#ifdef _LP64
+		union segtab ** const stp_p =
+		    &stp->seg_seg[(va >> XSEGSHIFT) & (NSEGPG - 1)];
+		if (__predict_false((stp = *stp_p) == NULL)) {
+			union segtab *nstp = pmap_segtab_alloc();
+#ifdef MULTIPROCESSOR
+			union segtab *ostp = atomic_cas_ptr(stp_p, NULL, nstp);
+			if (__predict_false(ostp != NULL)) {
+				pmap_segtab_free(nstp);
+				stp = ostp;
+			}
+#else
+			*stp_p = nstp;
+#endif /* MULTIPROCESSOR */
+			stp = nstp;
+		}
+		KASSERT(stp == pmap->pm_segtab->seg_seg[(va >> XSEGSHIFT) & (NSEGPG - 1)]);
+#endif /* _LP64 */
 		struct vm_page * const pg = pmap_pte_pagealloc();
 		if (pg == NULL) {
@@ -396,7 +462,8 @@
 		pte = (pt_entry_t *)MIPS_PHYS_TO_KSEG0(pa);
 #endif
+		pt_entry_t ** const pte_p =
+		    &stp->seg_tab[(va >> SEGSHIFT) & (PMAP_SEGTABSIZE - 1)];
 #ifdef MULTIPROCESSOR
-		pt_entry_t *opte = atomic_cas_ptr(
-		    &stp->seg_tab[va >> SEGSHIFT], NULL, pte);
+		pt_entry_t *opte = atomic_cas_ptr(pte_p, NULL, pte);
 		/*
 		 * If another thread allocated the segtab needed for this va
@@ -408,6 +475,7 @@
 		}
 #else
-		stp->seg_tab[va >> SEGSHIFT] = pte;
-#endif
+		*pte_p = pte;
+#endif
+		KASSERT(pte == stp->seg_tab[(va >> SEGSHIFT) & (PMAP_SEGTABSIZE - 1)]);
 
 		pte += (va >> PGSHIFT) & (NPTEPG - 1);
Index: /trunk/src/sys/arch/mips/mips/pmap_tlb.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/pmap_tlb.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/pmap_tlb.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: pmap_tlb.c,v 1.1.2.11 2010/05/04 17:14:17 matt Exp $	*/
+/*	$NetBSD: pmap_tlb.c,v 1.1.2.18 2011/05/13 17:36:39 matt Exp $	*/
 
 /*-
@@ -32,5 +32,5 @@
 #include <sys/cdefs.h>
 
-__KERNEL_RCSID(0, "$NetBSD: pmap_tlb.c,v 1.1.2.11 2010/05/04 17:14:17 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: pmap_tlb.c,v 1.1.2.18 2011/05/13 17:36:39 matt Exp $");
 
 /*
@@ -82,5 +82,5 @@
  * we are updating a PTE and that PTE previously was invalid and therefore
  * couldn't support an active mapping, there's no need for an IPI since there
- * can be no TLB entry to invalidate.  The other case is when we change a PTE
+ * can't be a TLB entry to invalidate.  The other case is when we change a PTE
  * to be modified we just update the local TLB.  If another TLB has a stale
  * entry, a TLB MOD exception will be raised and that will cause the local TLB
@@ -123,7 +123,9 @@
  */
 
+#include "opt_multiprocessor.h"
 #include "opt_sysv.h"
 #include "opt_cputype.h"
 #include "opt_mips_cache.h"
+#include "opt_multiprocessor.h"
 
 #include <sys/param.h>
@@ -147,7 +149,7 @@
 	.ti_name = "tlb0",
 	.ti_asid_hint = 1,
-	.ti_asid_mask = MIPS_TLB_NUM_PIDS - 1,
-	.ti_asid_max = MIPS_TLB_NUM_PIDS - 1,
-	.ti_asids_free = MIPS_TLB_NUM_PIDS - 1,
+	.ti_asid_mask = __builtin_constant_p(MIPS_TLB_NUM_PIDS) ? MIPS_TLB_NUM_PIDS - 1 : 0,
+	.ti_asid_max = __builtin_constant_p(MIPS_TLB_NUM_PIDS) ? MIPS_TLB_NUM_PIDS - 1 : 0,
+	.ti_asids_free = __builtin_constant_p(MIPS_TLB_NUM_PIDS) ? MIPS_TLB_NUM_PIDS - 1 : 0,
 	.ti_asid_bitmap[0] = 1,
 	.ti_wired = MIPS3_TLB_WIRED_UPAGES,
@@ -215,6 +217,6 @@
 }
 
-static void
-pmap_tlb_attach_evcnt(struct pmap_tlb_info *ti)
+void
+pmap_tlb_info_evcnt_attach(struct pmap_tlb_info *ti)
 {
 #ifdef MULTIPROCESSOR
@@ -227,5 +229,5 @@
 	evcnt_attach_dynamic(&ti->ti_evcnt_synci_all,
 	    EVCNT_TYPE_MISC, &ti->ti_evcnt_synci_asts,
-	    ti->ti_name, "iacche full syncs");
+	    ti->ti_name, "icache full syncs");
 	evcnt_attach_dynamic(&ti->ti_evcnt_synci_pages,
 	    EVCNT_TYPE_MISC, &ti->ti_evcnt_synci_asts,
@@ -238,4 +240,7 @@
 	    ti->ti_name, "icache pages deferred");
 #endif /* MULTIPROCESSOR */
+	evcnt_attach_dynamic(&ti->ti_evcnt_asid_reinits,
+	    EVCNT_TYPE_MISC, NULL,
+	    ti->ti_name, "asid pool reinit");
 }
 
@@ -248,5 +253,5 @@
 		KASSERT(ti == &pmap_tlb0_info);
 		mutex_init(ti->ti_lock, MUTEX_DEFAULT, IPL_SCHED);
-		if (!CPUISMIPSNN) {
+		if (!CPUISMIPSNN || !__builtin_constant_p(MIPS_TLB_NUM_PIDS)) {
 			ti->ti_asid_max = mips_options.mips_num_tlb_entries - 1;
 			ti->ti_asids_free = ti->ti_asid_max;
@@ -262,13 +267,12 @@
 #ifdef MULTIPROCESSOR
 		const u_int icache_way_pages =
-			mips_cache_info.mci_picache_way_size >> PGSHIFT; 
+			mips_cache_info.mci_picache_way_size >> PGSHIFT;
 		KASSERT(icache_way_pages <= 8*sizeof(pmap_tlb_synci_page_mask));
 		pmap_tlb_synci_page_mask = icache_way_pages - 1;
 		pmap_tlb_synci_map_mask = ~(~0 << icache_way_pages);
-		printf("tlb0: synci page mask %#x and map mask %#x used for %u pages\n", 
+		printf("tlb0: synci page mask %#x and map mask %#x used for %u pages\n",
 		    pmap_tlb_synci_page_mask, pmap_tlb_synci_map_mask,
 		    icache_way_pages);
 #endif
-		pmap_tlb_attach_evcnt(ti);
 		return;
 #ifdef MULTIPROCESSOR
@@ -289,5 +293,6 @@
 	snprintf(ti->ti_name, sizeof(ti->ti_name), "tlb%u", ti->ti_index);
 
-	pmap_tlb_attach_evcnt(ti);
+	KASSERT(ti != &pmap_tlb0_info);
+	pmap_tlb_info_evcnt_attach(ti);
 
 	/*
@@ -372,6 +377,8 @@
 		 * allocate a new ASID.
 		 */
+		pmap_tlb_asid_check();
 		const u_int asids_found = tlb_record_asids(ti->ti_asid_bitmap,
 		    ti->ti_asid_mask);
+		pmap_tlb_asid_check();
 		KASSERT(asids_found == pmap_tlb_asid_count(ti));
 		if (__predict_false(asids_found >= ti->ti_asid_max / 2)) {
@@ -432,4 +439,8 @@
 #endif
 
+	KASSERT(cpu_intr_p());
+	KASSERTMSG(ci->ci_cpl >= IPL_SCHED,
+	    ("%s: cpl (%d) < IPL_SCHED (%d)",
+	    __func__, ci->ci_cpl, IPL_SCHED));
 	TLBINFO_LOCK(ti);
 
@@ -447,5 +458,7 @@
 			 */
 			KASSERT(pai->pai_asid != 0);
+			pmap_tlb_asid_check();
 			tlb_invalidate_asids(pai->pai_asid, pai->pai_asid + 1);
+			pmap_tlb_asid_check();
 		} else if (pai->pai_asid) {
 			/*
@@ -470,5 +483,7 @@
 		 * We need to invalidate all global TLB entries.
 		 */
+		pmap_tlb_asid_check();
 		tlb_invalidate_globals();
+		pmap_tlb_asid_check();
 		break;
 	case TLBINV_ALL:
@@ -610,5 +625,7 @@
 	if (pm == pmap_kernel() || PMAP_PAI_ASIDVALID_P(pai, ti)) {
 		va |= pai->pai_asid << MIPS_TLB_PID_SHIFT;
+		pmap_tlb_asid_check();
 		rv = tlb_update(va, pt_entry);
+		pmap_tlb_asid_check();
 	}
 #ifdef MULTIPROCESSOR
@@ -631,5 +648,7 @@
 	if (pm == pmap_kernel() || PMAP_PAI_ASIDVALID_P(pai, ti)) {
 		va |= pai->pai_asid << MIPS_TLB_PID_SHIFT;
+		pmap_tlb_asid_check();
 		tlb_invalidate_addr(va);
+		pmap_tlb_asid_check();
 	}
 #ifdef MULTIPROCESSOR
@@ -763,5 +782,9 @@
 		atomic_or_ulong(&ci->ci_flags, CPUF_USERPMAP);
 #endif /* MULTIPROCESSOR */
+		ci->ci_pmap_asid_cur = pai->pai_asid;
 		tlb_set_asid(pai->pai_asid);
+		pmap_tlb_asid_check();
+	} else {
+		printf("%s: l (%p) != curlwp %p\n", __func__, l, curlwp);
 	}
 	TLBINFO_UNLOCK(ti);
@@ -769,5 +792,5 @@
 #ifdef DEBUGXX
 	if (pmapdebug & (PDB_FOLLOW|PDB_TLBPID)) {
-		printf("pmap_tlb_asid_alloc: curlwp %d.%d '%s' ",
+		printf("%s: curlwp %d.%d '%s' ", __func__,
 		    curlwp->l_proc->p_pid, curlwp->l_lid,
 		    curlwp->l_proc->p_comm);
@@ -784,20 +807,27 @@
 	/*
 	 * The kernel pmap is aways onproc and active and must never have
-	 * those bits cleared.
-	 */
-	if (pm != pmap_kernel()) {
+	 * those bits cleared.  If pmap_remove_all was called, it has already
+	 * deactivated the pmap and thusly onproc will be 0 so there's nothing
+	 * to do.
+	 */
+	if (pm != pmap_kernel() && pm->pm_onproc != 0) {
 		struct cpu_info * const ci = curcpu();
-		struct pmap_tlb_info * const ti = ci->ci_tlb_info;
-		TLBINFO_LOCK(ti);
-		/*
-		 * The bits in pm_onproc belonging to this TLB can only
-		 * be changed while this TLBs lock is held.
-		 */
-		atomic_and_32(&pm->pm_onproc, ~(1 << cpu_index(ci)));
-		TLBINFO_UNLOCK(ti);
+		const uint32_t cpu_mask = 1 << cpu_index(ci);
+		KASSERT(!cpu_intr_p());
+		KASSERTMSG(pm->pm_onproc & cpu_mask,
+		    ("%s: pmap %p onproc %#x doesn't include cpu %d (%p)",
+		    __func__, pm, pm->pm_onproc, cpu_index(ci), ci));
+		/*
+		 * The bits in pm_onproc that belong to this TLB can
+		 * be changed while this TLBs lock is not held as long
+		 * as we use atomic ops.
+		 */
+		atomic_and_32(&pm->pm_onproc, ~cpu_mask);
 		atomic_and_ulong(&ci->ci_flags, ~CPUF_USERPMAP);
 	}
 #elif defined(DEBUG)
+	curcpu()->ci_pmap_asid_cur = 0;
 	tlb_set_asid(0);
+	pmap_tlb_asid_check();
 #endif
 }
@@ -807,4 +837,5 @@
 {
 	KASSERT(pm != pmap_kernel());
+	KASSERT(kpreempt_disabled());
 #ifdef MULTIPROCESSOR
 	KASSERT(pm->pm_onproc == 0);
@@ -988,2 +1019,17 @@
 }
 #endif /* MULTIPROCESSOR */
+
+void
+pmap_tlb_asid_check(void)
+{
+#ifdef DEBUG
+	kpreempt_disable();
+	uint32_t tlb_hi;
+	__asm("mfc0 %0,$%1" : "=r"(tlb_hi) : "n"(MIPS_COP_0_TLB_HI));
+	uint32_t asid = (tlb_hi & MIPS_TLB_PID) >> MIPS_TLB_PID_SHIFT;
+	KDASSERTMSG(asid == curcpu()->ci_pmap_asid_cur,
+	   ("tlb_hi (%#x) asid (%#x) != current asid (%#x)",
+	    tlb_hi, asid, curcpu()->ci_pmap_asid_cur));
+	kpreempt_enable();
+#endif
+}
Index: /trunk/src/sys/arch/mips/mips/process_machdep.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/process_machdep.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/process_machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: process_machdep.c,v 1.29.62.5 2010/02/28 23:45:06 matt Exp $	*/
+/*	$NetBSD: process_machdep.c,v 1.29.62.6 2011/04/29 08:26:30 matt Exp $	*/
 
 /*
@@ -77,5 +77,5 @@
 
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
-__KERNEL_RCSID(0, "$NetBSD: process_machdep.c,v 1.29.62.5 2010/02/28 23:45:06 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: process_machdep.c,v 1.29.62.6 2011/04/29 08:26:30 matt Exp $");
 
 /*
@@ -104,8 +104,7 @@
 #include <sys/systm.h>
 #include <sys/proc.h>
-#include <sys/user.h>
 #include <sys/ptrace.h>
 
-#include <mips/reg.h>
+#include <mips/pcb.h>
 #include <mips/regnum.h>			/* symbolic register indices */
 #include <mips/locore.h>
@@ -138,4 +137,5 @@
 process_read_xfpregs(struct lwp *l, struct fpreg *regs, size_t *regslen_p)
 {
+	struct pcb * const pcb = lwp_getpcb(l);
 	KASSERT(*regslen_p == sizeof(struct fpreg));
 
@@ -145,7 +145,6 @@
 #endif
 
-	if (l->l_md.md_flags & MDP_FPUSED)
-		fpusave_lwp(l);
-	memcpy(regs, &l->l_addr->u_pcb.pcb_fpregs, *regslen_p);
+	fpu_save_lwp(l);
+	memcpy(regs, &pcb->pcb_fpregs, sizeof(*regs));
 	return 0;
 }
@@ -154,10 +153,10 @@
 process_write_xfpregs(struct lwp *l, const struct fpreg *regs, size_t regslen)
 {
+	struct pcb * const pcb = lwp_getpcb(l);
 	KASSERT(regslen <= sizeof(struct fpreg));
 
 #ifndef NOFPU
 	/* to load FPA contents next time when FP insn is executed */
-	if (l->l_md.md_flags & MDP_FPUSED)
-		fpudiscard_lwp(l);
+	fpu_discard();
 #endif /* !NOFPU */
 
@@ -167,5 +166,5 @@
 	KASSERT(regslen == sizeof(struct fpreg));
 #endif
-	memcpy(&l->l_addr->u_pcb.pcb_fpregs, regs, regslen);
+	memcpy(&pcb->pcb_fpregs, regs, regslen);
 	return 0;
 }
Index: /trunk/src/sys/arch/mips/mips/sig_machdep.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/sig_machdep.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/sig_machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: sig_machdep.c,v 1.16.14.4 2010/02/22 20:17:09 matt Exp $	*/
+/*	$NetBSD: sig_machdep.c,v 1.16.14.5 2011/04/29 08:26:30 matt Exp $	*/
 
 /*-
@@ -32,5 +32,5 @@
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
 	
-__KERNEL_RCSID(0, "$NetBSD: sig_machdep.c,v 1.16.14.4 2010/02/22 20:17:09 matt Exp $"); 
+__KERNEL_RCSID(0, "$NetBSD: sig_machdep.c,v 1.16.14.5 2011/04/29 08:26:30 matt Exp $"); 
 
 #include "opt_cputype.h"
@@ -41,5 +41,4 @@
 #include <sys/kernel.h>
 #include <sys/proc.h>
-#include <sys/user.h>
 #include <sys/signal.h>
 #include <sys/signalvar.h>
@@ -56,6 +55,6 @@
 getframe(struct lwp *l, int sig, int *onstack)
 {
-	struct proc *p = l->l_proc;
-	struct trapframe *tf = l->l_md.md_utf;
+	struct proc * const p = l->l_proc;
+	struct trapframe * const tf = l->l_md.md_utf;
  
 	/* Do we need to jump onto the signal stack? */
@@ -64,7 +63,6 @@
 	if (*onstack)
 		return (char *)l->l_sigstk.ss_sp + l->l_sigstk.ss_size;
-	else
-		return (void *)(intptr_t)tf->tf_regs[_R_SP];
-}		
+	return (void *)(intptr_t)tf->tf_regs[_R_SP];
+}
 
 struct sigframe_siginfo {
@@ -79,42 +77,27 @@
 sendsig_siginfo(const ksiginfo_t *ksi, const sigset_t *mask)
 {
-	struct lwp *l = curlwp;
-	struct proc *p = l->l_proc;
-	struct sigacts *ps = p->p_sigacts;
-	struct trapframe *tf = l->l_md.md_utf;
+	struct lwp * const l = curlwp;
+	struct proc * const p = l->l_proc;
+	struct sigacts * const sa = p->p_sigacts;
+	struct trapframe * const tf = l->l_md.md_utf;
 	int onstack, error;
-	int sig = ksi->ksi_signo;
-	struct sigframe_siginfo *fp = getframe(l, sig, &onstack);
-	ucontext_t uc;
-	size_t ucsz;
-	sig_t catcher = SIGACTION(p, sig).sa_handler;
+	const int signo = ksi->ksi_signo;
+	struct sigframe_siginfo *sf = getframe(l, signo, &onstack);
+	struct sigframe_siginfo ksf;
+	const sig_t catcher = SIGACTION(p, signo).sa_handler;
 
-	fp--;
+	sf--;
 
-        /* Build stack frame for signal trampoline. */
-        switch (ps->sa_sigdesc[sig].sd_vers) {
-        case 0:         /* handled by sendsig_sigcontext */
-        case 1:         /* handled by sendsig_sigcontext */
-        default:        /* unknown version */
-                printf("sendsig_siginfo: bad version %d\n",
-                    ps->sa_sigdesc[sig].sd_vers);
-                sigexit(l, SIGILL);
-        case 2:
-                break;
-        }
+	ksf.sf_si._info = ksi->ksi_info;
+	ksf.sf_uc.uc_flags = _UC_SIGMASK
+	    | (l->l_sigstk.ss_flags & SS_ONSTACK ? _UC_SETSTACK : _UC_CLRSTACK);
+	ksf.sf_uc.uc_sigmask = *mask;
+	ksf.sf_uc.uc_link = l->l_ctxlink;
+	memset(&ksf.sf_uc.uc_stack, 0, sizeof(ksf.sf_uc.uc_stack));
+	sendsig_reset(l, signo);
 
-        uc.uc_flags = _UC_SIGMASK
-            | ((l->l_sigstk.ss_flags & SS_ONSTACK)
-            ? _UC_SETSTACK : _UC_CLRSTACK);
-        uc.uc_sigmask = *mask;
-        uc.uc_link = l->l_ctxlink;
-        memset(&uc.uc_stack, 0, sizeof(uc.uc_stack));
-        ucsz = (char *)&uc.__uc_pad - (char *)&uc;
-        sendsig_reset(l, sig);
-        mutex_exit(p->p_lock);
-        cpu_getmcontext(l, &uc.uc_mcontext, &uc.uc_flags);
-	error = copyout(&ksi->ksi_info, &fp->sf_si, sizeof(ksi->ksi_info));
-	if (error == 0)
-		error = copyout(&uc, &fp->sf_uc, ucsz);
+	mutex_exit(p->p_lock);
+	cpu_getmcontext(l, &ksf.sf_uc.uc_mcontext, &ksf.sf_uc.uc_flags);
+	error = copyout(&ksf, sf, sizeof(ksf));
 	mutex_enter(p->p_lock);
 
@@ -133,12 +116,12 @@
 	 * to the signal trampoline to bounce us back.
 	 */
-	tf->tf_regs[_R_A0] = sig;
-	tf->tf_regs[_R_A1] = (intptr_t)&fp->sf_si;
-	tf->tf_regs[_R_A2] = (intptr_t)&fp->sf_uc;
+	tf->tf_regs[_R_A0] = signo;
+	tf->tf_regs[_R_A1] = (intptr_t)&sf->sf_si;
+	tf->tf_regs[_R_A2] = (intptr_t)&sf->sf_uc;
 
 	tf->tf_regs[_R_PC] = (intptr_t)catcher;
 	tf->tf_regs[_R_T9] = (intptr_t)catcher;
-	tf->tf_regs[_R_SP] = (intptr_t)fp;
-	tf->tf_regs[_R_RA] = (intptr_t)ps->sa_sigdesc[sig].sd_tramp;
+	tf->tf_regs[_R_SP] = (intptr_t)sf;
+	tf->tf_regs[_R_RA] = (intptr_t)sa->sa_sigdesc[signo].sd_tramp;
 
 	/* Remember that we're now on the signal stack. */
@@ -150,9 +133,21 @@
 sendsig(const ksiginfo_t *ksi, const sigset_t *mask)
 {               
+	struct sigacts * const sa = curproc->p_sigacts;
+
+        /* Build stack frame for signal trampoline. */
+        switch (sa->sa_sigdesc[ksi->ksi_signo].sd_vers) {
 #ifdef COMPAT_16    
-	if (curproc->p_sigacts->sa_sigdesc[ksi->ksi_signo].sd_vers < 2)
+        case 0:         /* handled by sendsig_sigcontext */
+        case 1:         /* handled by sendsig_sigcontext */
 		sendsig_sigcontext(ksi, mask);
-	else    
-#endif  
+		break;
+#endif
+        case 2:
 		sendsig_siginfo(ksi, mask);
+                break;
+        default:        /* unknown version */
+                printf("%s: bad version %d\n", __func__,
+                    sa->sa_sigdesc[ksi->ksi_signo].sd_vers);
+                sigexit(curlwp, SIGILL);
+        }
 }       
